# About

This repository contains a collection of working, unfinished as well as
abandoned functions. They serve various tasks although many of them are related
to image processing tasks.

Note that the functions have been designed for usability and not necessarily for
speed and memory efficiency. The functions do some thorough checks of all the
passed arguments and are very flexible when it comes to parameter settings,
without cluttering the the function calls with countless unnecessary
parameters. Also note, that most functions are not necessarily compatible to GNU
Octave, Scilab and/or other software that tries to offer a free alternative to
Matlab. Although it often would only require trivial changes to make it
compatible. Concerning GNU octave, one could probably obtain almost complete
compatibility by simply removing the input parser.

# License

Unless specified otherwise, all the files are licensed under GPLv3 and contain
the following license information

Copyright 2012, 2013 Laurent Hoeltgen <laurent.hoeltgen@gmail.com>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
Street, Fifth Floor, Boston, MA 02110-1301, USA.

# Comments

Many parts are work in progress and subject to change in the future. This is
especially true for the structure of the repository. In the long term, it is
planned to achieve a reasonable layout using toolboxes and classes.

There are a certain number of external dependencies. For the time being, they
are:

- PAQ8o6: available from: http://cs.fit.edu/~mmahoney/compression/#paq
- JBIGKit: available from: http://www.cl.cam.ac.uk/~mgk25/jbigkit/

Only the binaries are required. The methods that require these binaries are
Linux specific and do not work on Windows machines.

The following dependency is contained in the repository:

- FED: available from: http://www.mia.uni-saarland.de/Research/SC_FED.shtml

Other dependencies might be required in future versions.